"""Calculate the mean, median, and standard deviation of a series of numbers entered by the user."""

from math import sqrt, pow


def main():
    print('This program computes mean, median and standard deviation.')

    values = get_numbers()
    count = len(values)
    if count >= 2:
        mean = calculate_mean(values)
        standard_deviation = calculate_standard_deviation(values, mean)
        median = calculate_median(values)

        print(f'\nThe mean is {mean}')
        print(f'The standard deviation is {standard_deviation}')
        print(f'The median is {median}')
    else:
        print('\nStatistics will not be computed when fewer than 2 values have been entered.')
        print(f'You entered {count} values.')


def get_numbers():
    numbers = []
    entry_as_string = get_entry_from_user()

    while entry_as_string != '':
        value = float(entry_as_string)
        numbers.append(value)
        entry_as_string = get_entry_from_user()
    return numbers


def get_entry_from_user():
    return input('Enter a number (<Enter> to quit) >> ')


def calculate_mean(numbers):
    total = 0.0
    for num in numbers:
        total = total + num
    return total / len(numbers)


def calculate_standard_deviation(numbers, mean):
    sum_of_deviations_squared = 0.0
    for number in numbers:
        deviation = number - mean
        sum_of_deviations_squared += pow(deviation, 2)
    return sqrt(sum_of_deviations_squared / (len(numbers) - 1))


def calculate_median(numbers):
    numbers.sort()
    size = len(numbers)
    middle_position = size // 2
    if size % 2 == 0:
        median = (numbers[middle_position] + numbers[middle_position - 1]) / 2.0
    else:
        median = numbers[middle_position]
    return median


if __name__ == '__main__':
    main()
